#include "SPI.h"
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"
#include <Adafruit_NeoPixel.h>

#define TFT_DC 9
#define TFT_CS 10
#define TFT_RST 8

#define PIN 2
#define NUMPIXELS 16

Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_RST);
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel strip(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

const int ttp223Pin = 3;

bool CapteurToucher = false;

void setup() {
  Serial.begin(9600);

  pinMode(ttp223Pin, INPUT);

  pinMode(TFT_CS, OUTPUT);
  pinMode(7, OUTPUT);
  digitalWrite(TFT_CS, HIGH);
  digitalWrite(7, OUTPUT);

  tft.begin();
  tft.setRotation(1);  // Inverser la direction du texte

  uint8_t x = tft.readcommand8(ILI9341_RDMODE);

  strip.begin();
  strip.show();  
  strip.setBrightness(50); 
}

void loop() {
  int ttp223State = digitalRead(ttp223Pin);
  if (ttp223State == HIGH) {
    CapteurToucher = true;
  }

  if (CapteurToucher) {
    tft.fillScreen(ILI9341_WHITE); // couleur fond
    tft.setCursor(0, 0);
    tft.setTextColor(ILI9341_BLACK); // coueleur texte qst
    tft.setTextSize(3);// taille texte qst

    tft.print("What is the movie with '007'?"); //Question posée

    tft.fillRect(10, 80, 140, 60, ILI9341_BLUE); //1ere reponse + rectangle : largeur ecran x :0 à 320 et y : 0 à 220
    tft.setCursor(35, 105); // debut ecriture
    tft.setTextColor(ILI9341_WHITE); // couleur texte
    tft.setTextSize(1.75); // taille texte
    tft.print("Mission impossible");

    tft.fillRect(170, 80, 140, 60, ILI9341_RED); //reponse + rectangle
    tft.setCursor(210, 105);
    tft.print("James Bond");

    tft.fillRect(10, 160, 140, 60, ILI9341_GREEN); //reponse + rectangle
    tft.setCursor(60, 190);
    tft.print("Top Gun");

    tft.fillRect(170, 160, 140, 60, ILI9341_ORANGE); // reponse + rectangle
    tft.setCursor(220, 190);
    tft.print("OSS 117");

    pixels.fill(pixels.Color(255, 255, 255));
    colorWipe(strip.Color(255,255,255), 2000);
    theaterChase(strip.Color(255, 255, 255), 50);
    colorWipe(strip.Color(255,255,255), 0);
    strip.show();
    
  } else {
    tft.fillScreen(ILI9341_BLACK);
    tft.setCursor(0, 0);
  }

  delay(1000);
}

void colorWipe(uint32_t color, int wait)
{
  for(int i=0; i<strip.numPixels(); i++)
  { 
    strip.setPixelColor(i, color);
    strip.show();
    delay(wait);
  }
}

void theaterChase(uint32_t color, int wait)
{
  for(int a=0; a<10; a++)
  {  
    for(int b=0; b<3; b++)
    { 
      strip.clear();
      for(int c=b; c<strip.numPixels(); c += 3)
      {
        strip.setPixelColor(c, color);
      }
      strip.show();
      delay(wait);
    }
  }
}
